//-----------------------------------------------------------------------------
//        Asignatura INFORMATICA INDUSTRIAL
//        Grado en Ingenieria Electronica Industrial y Automatica
//        Escuela de Ingenierias Industriales. Universidad de Valladolid
//-----------------------------------------------------------------------------
//             Ejemplo de comunicacion con colas de mensajes
//Este programa clienteCad.cpp funciona sincronizadamente con servidorCad.cpp
//Ilustra el paradigma CLIENTE - SERVIDOR empleando COLAS DE MENSAJES
//El proceso cliente envia una cadena al servidor y la recibe en mayusculas
//Los procesos cliente y servidor funcionan sincronizadamente. Ambos procesos
//funcionan indefinidamente hasta que se introduce * en el cliente
//-----------------------------------------------------------------------------
//IMPORTANTE.servidorCad debe ejecutarse primero pues es el que crea los IPCS
//-----------------------------------------------------------------------------
//Compilar:    g++  clienteCad.cpp  o clienteCad -ltr
//-----------------------------------------------------------------------------
// Este software ha sido desarrollado por Eusebio de la Fuente y
// Rogelio Mazaeda dentro del programa de Innovacion Docente 2014-15
// de la Universidad de Valladolid. Julio 2015.
//-----------------------------------------------------------------------------


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <string>
#include "colamsg.hpp"
#define TAMCADENA 15
using namespace std;

int main ()
{
    string strMin;
    char cadMin[TAMCADENA], cadMay[TAMCADENA];

    colamsg colaMay("colaMayusculas", 0 , RDONLY); //Abrimos la cola de las mayusc. para leer solo
    colamsg colaMin("colaMinusculas", 0 , WRONLY); //Abrimos la cola de las minusc. para escribir solo

    do
    {
        cout << "Intro cadena (menos de " << TAMCADENA << "caract):" ;
        getline (cin,strMin);
        strcpy(cadMin,strMin.c_str());
        colaMin.send(cadMin,  TAMCADENA*sizeof(char));
        colaMay.receive(cadMay, TAMCADENA*sizeof(char));
        cout << "Recibido de servidor: " << cadMay << endl;
    }
    while(cadMin[0]!='*'); // si el usuario introduce * como primer caracter el programa acaba

    colaMin.close();
    colaMay.close();
}
