//-----------------------------------------------------------------------------
//        Asignatura INFORMATICA INDUSTRIAL
//        Grado en Ingenieria Electronica Industrial y Automatica
//        Escuela de Ingenierias Industriales. Universidad de Valladolid
//-----------------------------------------------------------------------------
//Ejemplo de comunicacion con memoria compartida y sincronizacion con semaforos
//Este programa cliente.cpp funciona sincronizadamente con servidor.cpp
//Ilustra el paradigma CLIENTE - SERVIDOR empleando MEMORIA COMPARTIDA
//El proceso cliente envia una letra al servidor y la recibe en mayusculas
//Los procesos cliente y servidor funcionan sincronizadamente. Ambos procesos
//funcionan indefinidamente hasta que se introduce *
//-----------------------------------------------------------------------------
//IMPORTANTE.servidor debe ejecutarse primero pues es el que crea los IPCS
//-----------------------------------------------------------------------------
//Compilar:    g++  cliente.cpp  o cliente -ltr
//-----------------------------------------------------------------------------
// Este software ha sido desarrollado por Eusebio de la Fuente y
// Rogelio Mazaeda dentro del programa de Innovacion Docente 2014-15
// de la Universidad de Valladolid. Julio 2015.
//-----------------------------------------------------------------------------

#include <iostream>
#include "semaforo.hpp"
#include "memocomp.hpp"

int main(void)
{
    char *letra;    // puntero a la letra en memo compartida

    cout << "Este programa transforma cada caracter que introduzca por el teclado a mayuscula" << endl;
    cout << "Lo hace enviando el caracter a otro programa servidor mediante memoria compartida" << endl;
    cout << "IMPORTANTE: El programa servidor debe ser lanzado primero pues crea los IPCs (mecanismos de sinc y comun." << endl;
    cout << "Para terminar introduzca *" << endl;

    //Abrimos dos semaforos para la sincronizacion llamados sem1 y sem2 inicializados a 1 y 0 resp.por el servidor
    semaforo s1("sem1"); // abrimos s1. Tiene que tener el mismo nombre "sem1" que en servidor. Si no no conecta con el
    semaforo s2("sem2"); // abrimos s2. Tiene que tener el mismo nombre "sem1" que en servidor. Si no no conecta con el

    //Abriremos la zona de memo compartida de lect escrit y tamao 1 byte (sizeof char) creada por servidor
    //Tiene que tener el mismo nombre "memo" que en servidor. Si no, no conecta con la zona de memo compartida creada
    memocomp memo("memo", OPEN, RDWR, sizeof(char));
    letra = (char *)memo.getPointer(); //vinculamos esta memo a un puntero

    while(*letra != '*')// Introducir * para finalizar
    {
        cout << "Intro caracter: ";
        cin >> (*letra);
        s1.up();    //da paso al servidor. Ya est disponible la letra en memo
        s2.down();  //espera a que el servidor escriba la letra en mayuscula
        cout << "En mayusculas --> " << *letra << endl;
    }
    s1.close();     //cierra semaforo s1 porque ya no lo usar este proceso
    s2.close();     //cierra semaforo s2 porque ya no lo usar este proceso
    memo.cerrar();  //cierra memo shm_fd porque ya no lo usar este proceso

}


