//-----------------------------------------------------------------------------
//        Asignatura INFORMATICA INDUSTRIAL
//        Grado en Ingenieria Electronica Industrial y Automatica
//        Escuela de Ingenierias Industriales. Universidad de Valladolid
//-----------------------------------------------------------------------------
//--------------------------Clase semaforo-------------------------------------
//Define la clase semaforo empleando funciones POSIX
//El objetivo es una mayor facilidad para el uso de semaforos:
//  -Para CREAR semaforo:
//      semaforo S("misemaforo",valor); //Crea semaf S con nombre 'misemaforo'
//                                      //y lo inicializa a valor
//  -Para ABRIR semaforo:
//      semaforo("misemaforo");         //Abre semaf S con nombre 'misemaforo'
//                                      //El semaf debe haber sido creado antes
//  -Para SUBIR semaforo:
//      S.up();                         //Sube el semaforo S
//  -Para BAJAR semaforo:
//      S.down();                       //Baja el semaforo S
//  -Para CERRAR semaforo:
//      S.close();                      //Cierra el semaforo S
//  -Para DESTRUIR semaforo:
//      S.unlink();                     //Destruye el semaforo S
//-----------------------------------------------------------------------------
//Compilar:    g++  miprog.cpp  o miprog -lpthread
//-----------------------------------------------------------------------------
// Este software ha sido desarrollado por Eusebio de la Fuente y
// Rogelio Mazaeda dentro del programa de Innovacion Docente 2014-15
// de la Universidad de Valladolid. Julio 2015.
//-----------------------------------------------------------------------------


#ifndef SEMAFOROS
#define SEMAFOROS

#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <semaphore.h>
#include <string>
#define OPEN 0
#define CREAT 1
using namespace std;

class semaforo
{
    sem_t* id;
    char nombre[30];
public:
    semaforo(string strname, int val)//Para CREAR
    {
        char name[30];
        char nombreConUID[30];
        strcpy(name,strname.c_str());
        //para no tener conflicto con otros usarios crea nombre con el uid
        uid_t uid=getuid();
        sprintf(nombreConUID, "/%d",uid);
        strcat(nombreConUID,name);
        strcpy(nombre, nombreConUID);
        id = sem_open(nombre, O_CREAT, 0644, val);//con perm 0644
    }

    semaforo(string strname)//para ABRIR
    {
        char name[30];
        char nombreConUID[30];
        strcpy(name,strname.c_str());

        //para no tener conflicto con otros usarios crea nombre con el uid
        uid_t uid=getuid();
        sprintf(nombreConUID, "/%d",uid);
        strcat(nombreConUID,name);
        strcpy(nombre, nombreConUID);
        id = sem_open(nombre, 0);
        if(id==SEM_FAILED)
        {
            printf("ERROR al abrir semaforo. Seguramente no este creado previamente\n");
            exit(-1);
        }
    }

    int down()
    {
        int error=sem_wait(id);
        return(error); //devuelve 0 si ok
    }

    int up()
    {
        int error=sem_post(id);
        return(error); //devuelve 0 si ok
    }

    int get()
    {
        int val;
        int error=sem_getvalue (id, &val);
        if(!error) return val;
        else printf("ERRoR\n");
    }

    int close()
    {
        int error=sem_close(id);
        return(error); //devuelve 0 si ok
    }

    int unlink()
    {
        int error=sem_unlink(nombre);;
        return(error); //devuelve 0 si ok
    }
};



#endif

