//-----------------------------------------------------------------------------
//        Asignatura INFORMATICA INDUSTRIAL
//        Grado en Ingenieria Electronica Industrial y Automatica
//        Escuela de Ingenierias Industriales. Universidad de Valladolid
//-----------------------------------------------------------------------------
//Ejemplo de comunicacion con memoria compartida y sincronizacion con semaforos
//Este programa servidor.cpp funciona sincronizadamente con cliente.cpp
//Ilustra el paradigma CLIENTE - SERVIDOR empleando MEMORIA COMPARTIDA
//El proceso servidor recibe una letra del cliente y la devuelve en mayusculas
//Los procesos cliente y servidor funcionan sincronizadamente. Para finalizar
//introducir *
//-----------------------------------------------------------------------------
//IMPORTANTE.servidor debe ejecutarse primero pues es el que crea los IPCS
//-----------------------------------------------------------------------------
//Compilar:    g++  servidor.cpp  o servidor -ltr
//-----------------------------------------------------------------------------
// Este software ha sido desarrollado por Eusebio de la Fuente y
// Rogelio Mazaeda dentro del programa de Innovacion Docente 2014-15
// de la Universidad de Valladolid. Julio 2015.
//-----------------------------------------------------------------------------

#include <stdlib.h>
#include <iostream>
#include "semaforo.hpp"
#include "memocomp.hpp"

int main(void)
{
    char *letra;    // puntero a la letra en memo compartida

    cout << "Este es el programa SERVIDOR y transforma cada caracter que recibe a mayuscula" << endl;
    cout << "La comunicacion con el cliente se realiza mediante memoria compartida" << endl;
    cout << "y la sincronizacion mediante semaforos" << endl;
    cout << "IMPORTANTE: El programa servidor debe ser lanzado siempre primero pues crea los IPCs (mecanismos de sinc y comun." << endl;

    //Creamos dos semaforos para la sincronizacion llamados sem1 y sem2 inicializados a 1 y 0 resp.
    semaforo s1("sem1", 0); // Creamos s1 inicializado a 0
    semaforo s2("sem2", 0); // Creamos s2 inicializado a 0
    //creamos una zona de memo compartida de lect escrit y tamao 1 byte (sizeof char)
    memocomp memo("memo", CREAT, RDWR, sizeof(char));
    letra = (char *)memo.getPointer(); //vinculamos esta memo a un puntero

    while(*letra != '*')    //mientras no llegue un *
    {
        s1.down();//espera a que cliente escriba minusc en memo compartida
        *letra=toupper(*letra);
        cout << "servidor: " << *letra << endl;
        s2.up(); //da paso a cliente para que lea la mayuscula
    }

    s1.close();     //cierra semaforo s1 porque ya no lo usar este proceso
    s2.close();     //cierra semaforo s2 porque ya no lo usar este proceso
    memo.cerrar();  //cierra memo porque ya no lo usar este proceso

    //Eliminamos ipcs
    memo.unlink();  //destruye la memoria compartida que habamos solicitado
    s1.unlink();    //destruye semaforo s1 porque ya no lo usar ningn proceso
    s2.unlink();    //destruye semaforo s2 porque ya no lo usar ningn proceso

}



